|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
java.lang.Objectorg.apache.wicket.Component
org.apache.wicket.MarkupContainer
org.apache.wicket.markup.html.WebMarkupContainer
org.apache.wicket.markup.html.form.LabeledWebMarkupContainer
org.apache.wicket.markup.html.form.FormComponent
org.apache.wicket.markup.html.form.FormComponentPanel
org.apache.wicket.markup.html.form.upload.MultiFileUploadField
public class MultiFileUploadField
Form component that allows the user to select multiple files to upload via a single <input
type="file"/> field.
Notice that this component clears its model at the end of the request, so the uploaded files MUST
be processed within the request they were uploaded.
Uses javascript implementation from
http://the-stickman.com/web-development/javascript/upload-multiple-files-with-a-single-file-element/
For customizing caption text see RESOURCE_LIMITED and RESOURCE_UNLIMITED
For an example of styling using CSS see the upload example in wicket-examples
| Nested Class Summary |
|---|
| Nested classes/interfaces inherited from class org.apache.wicket.markup.html.form.FormComponent |
|---|
FormComponent.AbstractVisitor, FormComponent.IVisitor |
| Nested classes/interfaces inherited from class org.apache.wicket.Component |
|---|
Component.ComponentModelChange, Component.EnabledChange, Component.VisibilityChange |
| Field Summary | |
|---|---|
static java.lang.String |
RESOURCE_LIMITED
Resource key used to retrieve caption message for when a limit on the number of uploads is specified. |
static java.lang.String |
RESOURCE_UNLIMITED
Resource key used to retrieve caption message for when no limit on the number of uploads is specified. |
static int |
UNLIMITED
Represents an unlimited max count of uploads |
| Fields inherited from class org.apache.wicket.markup.html.form.FormComponent |
|---|
FLAG_CONVERT_EMPTY_INPUT_STRING_TO_NULL, VALUE_SEPARATOR |
| Fields inherited from class org.apache.wicket.Component |
|---|
ENABLE, FLAG_RESERVED1, FLAG_RESERVED2, FLAG_RESERVED3, FLAG_RESERVED4, FLAG_RESERVED5, FLAG_RESERVED6, FLAG_RESERVED7, FLAG_RESERVED8, PATH_SEPARATOR, RENDER |
| Constructor Summary | |
|---|---|
MultiFileUploadField(java.lang.String id)
Constructor |
|
MultiFileUploadField(java.lang.String id,
IModel model)
Constructor |
|
MultiFileUploadField(java.lang.String id,
IModel model,
int max)
Constructor |
|
MultiFileUploadField(java.lang.String id,
int max)
Constructor |
|
| Method Summary | |
|---|---|
protected java.lang.Object |
convertValue(java.lang.String[] value)
Subclasses should overwrite this if the conversion is not done through the type field and the IConverter. |
java.lang.String[] |
getInputAsArray()
Gets the request parameters for this component as strings. |
protected void |
onBeforeRender()
Called just before a component is rendered. |
protected void |
onComponentTag(ComponentTag tag)
Processes the component tag. |
protected void |
onDetach()
Sets the temporary converted input value to null. |
void |
renderHead(IHeaderResponse response)
Render to the web response whatever the component wants to contribute to the head section. |
void |
updateModel()
Updates this components model from the request, it expects that the object is already converted through the convertInput() call that is called by the validate() method when a form is being processed. |
| Methods inherited from class org.apache.wicket.markup.html.form.FormComponentPanel |
|---|
checkRequired, newHeaderPartContainer, onComponentTagBody, renderHead |
| Methods inherited from class org.apache.wicket.markup.html.form.FormComponent |
|---|
add, clearInput, convertInput, error, getBehaviors, getConvertedInput, getForm, getInput, getInputName, getModelValue, getRawInput, getType, getValidatorKeyPrefix, getValidators, getValue, hasRawInput, inputAsInt, inputAsInt, inputAsIntArray, inputChanged, internalOnModelChanged, invalid, isInputNullable, isMultiPart, isPersistent, isRequired, isValid, onDisabled, onInvalid, onValid, processChildren, processInput, setConvertedInput, setLabel, setModelValue, setModelValue, setPersistent, setRequired, setType, shouldTrimInput, supportsPersistence, trim, valid, validate, validateRequired, validateValidators, visitFormComponentsPostOrder |
| Methods inherited from class org.apache.wicket.markup.html.form.LabeledWebMarkupContainer |
|---|
getLabel, setLabelInternal |
| Methods inherited from class org.apache.wicket.markup.html.WebMarkupContainer |
|---|
getMarkupType, getWebPage |
| Methods inherited from class org.apache.wicket.MarkupContainer |
|---|
add, addOrReplace, autoAdd, autoAdd, contains, findMarkupStream, get, getAssociatedMarkupStream, getMarkupStream, hasAssociatedMarkup, internalAdd, isTransparentResolver, iterator, iterator, newMarkupResourceStream, onRender, remove, remove, removeAll, renderAll, renderAssociatedMarkup, renderComponentTagBody, replace, setMarkupStream, setModel, size, toString, toString, visitChildren, visitChildren |
| Methods inherited from class java.lang.Object |
|---|
clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait |
| Field Detail |
|---|
public static final int UNLIMITED
public static final java.lang.String RESOURCE_LIMITED
public static final java.lang.String RESOURCE_UNLIMITED
| Constructor Detail |
|---|
public MultiFileUploadField(java.lang.String id)
id -
public MultiFileUploadField(java.lang.String id,
int max)
id - max - max number of files a user can upload
public MultiFileUploadField(java.lang.String id,
IModel model)
id - model -
public MultiFileUploadField(java.lang.String id,
IModel model,
int max)
id - model - max - max number of files a user can upload| Method Detail |
|---|
protected void onComponentTag(ComponentTag tag)
FormComponent
onComponentTag in class FormComponentPaneltag - Tag to modifyFormComponentPanel.onComponentTag(org.apache.wicket.markup.ComponentTag)protected void onBeforeRender()
Component
*NOTE* If you override this, you *must* call super.onBeforeRender() within your
implementation.
Because this method is responsible for cascading Component.onBeforeRender() call to its
children it is strongly recommended that super call is made at the end of the override.
onBeforeRender in class ComponentComponent.onBeforeRender()public void renderHead(IHeaderResponse response)
IHeaderContributor
renderHead in interface IHeaderContributorresponse - Response objectIHeaderContributor.renderHead(org.apache.wicket.markup.html.IHeaderResponse)public java.lang.String[] getInputAsArray()
FormComponent
getInputAsArray in class FormComponentFormComponent.getInputAsArray()
protected java.lang.Object convertValue(java.lang.String[] value)
throws ConversionException
FormComponent
convertValue in class FormComponentvalue - The value can be the getInput() or through a cookie
ConversionException - If input can't be convertedFormComponent.convertValue(java.lang.String[])public void updateModel()
FormComponentsetModelObject(getConvertedInput());DO NOT CALL THIS METHOD DIRECTLY UNLESS YOU ARE SURE WHAT YOU ARE DOING. USUALLY UPDATING YOUR MODEL IS HANDLED BY THE FORM, NOT DIRECTLY BY YOU.
updateModel in class FormComponentFormComponent.updateModel()protected void onDetach()
FormComponent
onDetach in class FormComponentComponent.onDetach()
|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||